unit FaceDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, OleCtrls, SHDocVw;

type
  TdlgFace = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure OnBefore2(ASender: TObject; const pDisp: IDispatch; var URL,
      Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
  private
    { Private declarations }
  public
    { Public declarations }

    const WM_MY_MSG_EMOTION_SELECTED = $0400 + 112;
  end;

var
  dlgFace: TdlgFace;
  dlgMainHwnd : HWND;
implementation

{$R *.dfm}

procedure TdlgFace.FormCreate(Sender: TObject);   //ڴʱ
var
     strUrl:string;
begin
     dlgFace.Width := 270;
     dlgFace.Height := 156;
     dlgFace.WebBrowser1.Width := 270;
     dlgFace.WebBrowser1.Height := 156;
     strUrl:=ExtractFilePath(Paramstr(0))+'Emotion\face.htm';
     WebBrowser1.Navigate(strUrl);
end;

procedure TdlgFace.FormDeactivate(Sender: TObject);
begin
     self.Hide;
end;

procedure TdlgFace.OnBefore2(ASender: TObject; const pDisp: IDispatch; var URL,
  Flags, TargetFrameName, PostData, Headers: OleVariant; var Cancel: WordBool);
  var
  strurl : String;
  ipos : Integer;
  strnumber : String;
begin
    strurl := String(URL);
    ipos := Pos('=', strurl);
   // strnumber:=format('%3.0d', [ipos]);
   // MessageBox(Handle, PChar(strnumber), 'ddd', MB_OK);
    if (ipos <> 0) then
    begin
      strnumber := Copy(strurl, ipos + 1);
      PostMessage(dlgMainHwnd, WM_MY_MSG_EMOTION_SELECTED, strtoint(strnumber), 0);
      Cancel := true;
      self.Hide;
    end;
end;

end.
