#include "StdAfx.h"
#include "RichEditCtrlEx.h"
#include "RichEditHelper.h"

//˵
#define IDM_CLEAR_ALL				(WM_USER+201)						//ɾϢ
#define IDM_SELECT_ALL				(WM_USER+202)						//ȫѡ
#define IDM_COPY_STRING				(WM_USER+203)						//ַ
#define IDM_SAVE_STRING				(WM_USER+205)						//Ϣ
#define IDM_DELETE_STRING			(WM_USER+204)						//ɾַ
#define IDM_PASTE_STRING			(WM_USER+206)						//ճ
#define IDM_SAVE_AS					(WM_USER+207)						//ճ


CRichEditCtrlEx::CRichEditCtrlEx(void)
{
}

CRichEditCtrlEx::~CRichEditCtrlEx(void)
{
}


BEGIN_MESSAGE_MAP(CRichEditCtrlEx, CRichEditCtrl)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SETCURSOR()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(IDM_CLEAR_ALL, OnClearAll)
	ON_COMMAND(IDM_SELECT_ALL, OnSelectAll)
	ON_COMMAND(IDM_COPY_STRING, OnCopyString)
	ON_COMMAND(IDM_SAVE_STRING, OnSaveString)
	ON_COMMAND(IDM_DELETE_STRING, OnDeleteString)
	ON_COMMAND(IDM_PASTE_STRING, OnPasteString)
	ON_COMMAND(IDM_SAVE_AS, OnSaveAs)
	

END_MESSAGE_MAP()



//ɾϢ
VOID CRichEditCtrlEx::OnClearAll()
{
	//ɾϢ
	SetSel(0L,-1L);
	ReplaceSel(NULL);

	return;
}

//ȫѡ
VOID CRichEditCtrlEx::OnSelectAll()
{
	//ȫѡ
	SetSel(0L,-1L);

	return;
}

//ַ
VOID CRichEditCtrlEx::OnCopyString()
{
	//ַ
	Copy();

	return;
}

//ַ
VOID CRichEditCtrlEx::OnPasteString()
{
	Paste();
	return;
}

void CRichEditCtrlEx::OnSaveAs()
{
	CRichEditHelper::m_fnSaveOleImage(m_hWnd, m_ptOleImage.x, m_ptOleImage.y);
}

//Ϣ
VOID CRichEditCtrlEx::OnSaveString()
{
	return;
}

//ɾַ
VOID CRichEditCtrlEx::OnDeleteString()
{
	//ɾַ
	ReplaceSel(TEXT(""));

	return;
}

//////////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CRichEditCtrlEx, CRichEditCtrl)


//Ļ
bool CRichEditCtrlEx::CleanScreen()
{
	//Ļ
	SetSel(0,GetWindowTextLength());
	ReplaceSel(TEXT(""));

	return true;
}
//ҼϢ
VOID CRichEditCtrlEx::OnRButtonDown(UINT nFlags, CPoint Point)
{
	//ý
	SetFocus();
	CMenu PopMenu;

	//˵
	PopMenu.CreatePopupMenu();
	PopMenu.AppendMenu(0,IDM_COPY_STRING,TEXT("(&C) \tCtrl+C"));
	PopMenu.AppendMenu(0,IDM_SELECT_ALL,TEXT("ȫѡ(&A) \tCtrl+A"));
	PopMenu.AppendMenu(0,IDM_PASTE_STRING,TEXT("ճ(&V) \tCtrl+V"));
	if(CRichEditHelper::m_fnIsOleImage(m_hWnd, Point.x, Point.y))
	{
		m_ptOleImage = Point;
		PopMenu.AppendMenu(0,IDM_SAVE_AS,TEXT("Ϊ..."));
	}

	PopMenu.AppendMenu(0,IDM_CLEAR_ALL,TEXT("Ļ"));
	//PopMenu.AppendMenu(0,MF_SEPARATOR);
	//	PopMenu.AppendMenu(0,IDM_SAVE_STRING,TEXT("Ϣ..."));

	

	//ò˵
	UINT nSel=((GetSelectionType()!=SEL_EMPTY)?0:MF_GRAYED);
	PopMenu.EnableMenuItem(IDM_COPY_STRING,MF_BYCOMMAND|nSel);

	UINT nUndo=(CanUndo() ? 0 : MF_GRAYED );
	PopMenu.EnableMenuItem(IDM_DELETE_STRING, MF_BYCOMMAND | nSel | nUndo);
	UINT nPaste=(CanPaste() ? 0 : MF_GRAYED) ;
	PopMenu.EnableMenuItem(IDM_PASTE_STRING,MF_BYCOMMAND | nPaste);
	PopMenu.EnableMenuItem(IDM_SELECT_ALL,MF_BYCOMMAND);
	PopMenu.EnableMenuItem(IDM_CLEAR_ALL,MF_BYCOMMAND);// | nPaste);
	//ʾ˵
	ClientToScreen(&Point);
	PopMenu.TrackPopupMenu(TPM_RIGHTBUTTON,Point.x,Point.y,this);
	PopMenu.DestroyMenu();

	return;
}


void CRichEditCtrlEx::OnDblClick(LPARAM lParam)
{
	POINT pt = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

	wstring strPath = CRichEditHelper::m_fnGetOleObjectPathFromPoint(m_hWnd, pt.x, pt.y);
	if (!strPath.empty())
	{
		wstring strExePath = CRichEditHelper::GetCurrentPath() + _T("imageviewer.exe");
		::ShellExecute(NULL, _T("open"), strExePath.c_str(), strPath.c_str(), NULL, SW_SHOWNORMAL);
	}
}


LRESULT CRichEditCtrlEx::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{	
	if(message == WM_LBUTTONDBLCLK)
	{
		OnDblClick(lParam);
		return 0L;
	}
	return CRichEditCtrl::WindowProc(message, wParam, lParam);
}