#pragma once
#include <string>
using namespace std;


typedef void (__stdcall *FnNiuniu_InitGdiPlus)();
typedef UINT (__stdcall *FnNiuniu_InitRichEditWnd)(HWND hParentHwnd, HWND hRichEdit);

typedef BOOL (__stdcall *FnNiuniu_HasOleObjectFromPoint)(HWND hWnd, int xPos, int yPos);
typedef UINT (__stdcall *FnNiuniu_SaveOleObjectFromPoint)(HWND hWnd, int xPos, int yPos);
typedef LPCTSTR (__stdcall *FnNiuniu_GetOleObjectPathFromPoint)(HWND hWnd, int xPos, int yPos);

typedef BOOL (__stdcall *FnNiuniu_SetStartIndent)(HWND hWnd, int nSize);

typedef void (__stdcall *FnNiuniu_SetDefaultFont)(HWND hWnd, LPCTSTR lpFontName, int nFontSize,
								   COLORREF clrText, BOOL bBold, BOOL bItalic, 
								   BOOL bUnderLine, BOOL bIsLink);


typedef void (__stdcall *FnNiuniu_ReplaceSel)(HWND hWnd, LPCTSTR lpszText, LPCTSTR lpFontName,
							  int nFontSize,	COLORREF clrText, BOOL bBold, BOOL bItalic, 
							  BOOL bUnderLine, BOOL bIsLink, int nStartIndent);

typedef void (__stdcall *FnNiuniu_AppendMsg)(HWND hWndPtr, LPCTSTR strText);
typedef void (__stdcall *FnNiuniu_PasteMsg)(HWND hWndPtr, LPVOID lParam);
typedef UINT (__stdcall *FnNiuniu_InsertImage)(HWND hWnd, LPCTSTR strFilePath);

typedef LPCTSTR (__stdcall *FnNiuniu_GetRichTextContent)(HWND hwnd);
typedef void (__stdcall *FnNiuniu_GetSel)(HWND hWnd, LONG& nStartChar, LONG& nEndChar);
typedef int (__stdcall *FnNiuniu_SetSel)(HWND hWnd, LONG nStartChar, LONG nEndChar);
typedef LPCTSTR (__stdcall *FnNiuniu_GetSelText)(HWND hwnd, LONG lMin, LONG lMax);



class CRichEditHelper
{
public:
	CRichEditHelper(void);
	~CRichEditHelper(void);
	static wstring GetCurrentPath();
	static int Init();
	static FnNiuniu_InitGdiPlus m_fnInitGdiPlus;
	static FnNiuniu_GetOleObjectPathFromPoint m_fnGetOleObjectPathFromPoint;
	static FnNiuniu_PasteMsg m_fnAddPasteMsg;
	static FnNiuniu_InitRichEditWnd m_fnInitRichEditWnd;
	static FnNiuniu_GetRichTextContent m_fnGetRichTextContent;
	static FnNiuniu_HasOleObjectFromPoint m_fnIsOleImage;
	static FnNiuniu_SaveOleObjectFromPoint m_fnSaveOleImage;

	static FnNiuniu_SetStartIndent m_fnSetStartIndent;

	static FnNiuniu_GetSel m_fnGetSel;
	static FnNiuniu_SetSel m_fnSetSel;
	static FnNiuniu_SetDefaultFont m_fnSetDefaultFont;
	static FnNiuniu_ReplaceSel m_fnReplaceSel;
	static FnNiuniu_InsertImage m_fnInsertImage;
	static FnNiuniu_AppendMsg m_fnAppendMsg;
	static FnNiuniu_GetSelText m_fnGetSelText;

	static HMODULE m_hModule;
};
