#pragma once
#include <WTypes.h>
#include <tchar.h>
#include <string>
using std::wstring;


typedef enum ExtendFlagTypeEnum
{
	emPensize = 1,		//ûʴС
	emDrawType,			//Ѷ360
	emTrackColor,		//Զʶı߿ɫ
	emEditBorderColor,	//ıı߿ɫ
	emTransparent,		//͸
	emWindowAware,		//ǷDPIŴ
	emDetectSubWindowRect,	//ǷԶӴڣʱ 
	emSetSaveName,		//ñʱĿʼ
	emSetMagnifierBkColor, //÷Ŵ󾵵ıɫ͸
	emSetMagnifierLogoText, //÷ŴϵLOGOַʾݼ磺 ţţͼ(CTRL + SHIFT + A)
};

CHAR * UnicodeToAnsi(const WCHAR * lpszStr);
WCHAR * Utf8ToUnicode(const CHAR * lpszStr);
WCHAR * AnsiToUnicode(const CHAR * lpszStr);
CHAR * UnicodeToUtf8(const WCHAR * lpszStr);

class CScreenCaptureWrapper
{
public:
	CScreenCaptureWrapper(void);
	~CScreenCaptureWrapper(void);
	static int Init(wstring captureName);
	static int InitCapture(const wchar_t* szAuth, wstring captureName);
	static void InitParam(int flag, UINT_PTR flagvalue);
	static int DoCapture(const wchar_t* szDefaultSavePath, void* pCallBack, UINT_PTR hWndNotice, UINT_PTR noticeMsg, UINT_PTR hwndHideWhenCapture, int autoCapture, int x, int y, int width, int height);
	static bool IsUseful();
	
	static wstring GetDefaultSavePath();
	static void FreeLib();
private:
	static HMODULE m_hModule;
	
};
