unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, Buttons, StdCtrls, ComCtrls;

type
  TfrmMain = class(TForm)
    redChatMessage: TRichEdit;
    redSendMessage: TRichEdit;
    btnSend: TSpeedButton;
    btnFace: TSpeedButton;
    btnCapture: TSpeedButton;
    btnInsertImage: TSpeedButton;
    dlgInsertImage: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure btnInsertImageClick(Sender: TObject);
    procedure OnEmotionSelected(var nID : Integer);
    procedure btnCaptureClick(Sender: TObject);
    procedure btnFaceClick(Sender: TObject);
    procedure WndProc(var Message: TMessage);override;
    procedure WMNotify(var AMessage: TWMNotify); message WM_NOTIFY;
    procedure OnRichEditRecordDblClk(Sender: TObject);
    procedure redSendMessageDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     procedure AddMsgToRecord(lpText:Pchar);
     const WM_MY_MSG_SCREENNOTICE:Cardinal = WM_USER + 111;      //const WM_MY_MSG_SCREENNOTICE:Cardinal = $0400 + 111;
     const WM_MY_MSG_EMOTION_SELECTED:Cardinal = WM_USER + 112;  //const WM_MY_MSG_EMOTION_SELECTED:Cardinal = $0400 + 112;
     const EN_PASTE:Cardinal = $0800;
  end;

  function InitCaptureParamW(flag:Integer; flagvalue:Cardinal) : Integer; cdecl; stdcall; external 'NiuniuCapture.dll';
  function InitScreenCaptureW(szAuth:Pchar):integer; stdcall; external 'NiuniuCapture.dll';
  function StartScreenCaptureW(szDefaultSavePath:string; pCallBack: pointer;
     hWndNotice:hwnd; noticeMsg:integer; hwndHideWhenCapture:pointer; autoCapture:integer; x:integer; y:integer; width:integer; height:integer):integer; stdcall; external 'NiuniuCapture.dll';
  function Niuniu_InitRichEditWnd(hParentHwnd:HWND; hRichEdit:HWND):integer; stdcall;  external 'RichEditWrapper.dll';  //Լδ˵Ӧcdecl
  function Niuniu_GetRichTextContent(hwd:HWND):Pchar; stdcall;  external 'RichEditWrapper.dll';
  function Niuniu_InsertImage(hwd:HWND; strFilePath:Pchar):integer; stdcall; external 'RichEditWrapper.dll';
  procedure Niuniu_InitGdiPlus(); stdcall; external 'RichEditWrapper.dll';
  procedure Niuniu_SetSel(hWd:HWND; nStartChar:longint; nEndChar:longint); stdcall; external 'RichEditWrapper.dll';
  procedure Niuniu_ReplaceSel(hwd:HWND; lpszText:Pchar; lpFontName:Pchar; nFontSize:integer;
     clrText:TColorRef; bBold:Boolean; bItalic:Boolean; bUnderLine:Boolean; bIsLink:Boolean; nStartIndent:integer); stdcall; external 'RichEditWrapper.dll';
  function Niuniu_SetStartIndent(hwd:HWND; nSize:integer):boolean; stdcall; external 'RichEditWrapper.dll';
  procedure Niuniu_AppendMsg(hWndPtr:HWND; lpText:Pchar); stdcall; external 'RichEditWrapper.dll';
  procedure Niuniu_PasteMsg(hWndPtr:HWND; lpText:Longint); stdcall; external 'RichEditWrapper.dll';
  function Niuniu_GetSelText(hWndPtr:HWND; crMin:Integer; crMax:Integer) : Pchar; stdcall; external 'RichEditWrapper.dll';
  function Niuniu_GetOleObjectPathFromPoint(hWnd:HWND; xPos:Integer; yPos:Integer) : Pchar; stdcall; external 'RichEditWrapper.dll';
var
  frmMain: TfrmMain;
  strCapturePath :  string;
implementation

{$R *.dfm}

uses FaceDlg, RichEdit, ShellAPI;

procedure TfrmMain.FormCreate(Sender: TObject);      //ʱʼ
type
     ExtendFlagTypeEnum = (emPensize = 1,		//ûʴС
          emDrawType,			//Ѷ360
          emTrackColor,		//Զʶı߿ɫ
          emEditBorderColor,	//ıı߿ɫ
          emTransparent,		//͸
          emWindowAware,		//ǷDPIŴ
          emDetectSubWindowRect,	//ǷԶӴڣʱ
          emSetSaveName,		//ñʱĿʼ
          emSetMagnifierBkColor, //÷Ŵ󾵵ıɫ͸
          emSetMagnifierLogoText //÷ŴϵLOGOַʾݼ磺 ţţͼ(CTRL + SHIFT + A)
     );
begin
     InitCaptureParamW(Integer(ExtendFlagTypeEnum.emPensize), 2);	//߿
		 InitCaptureParamW(Integer(ExtendFlagTypeEnum.emDrawType), 0);	//÷Ŵ󾵷0 Ѷ   1 360
		 InitCaptureParamW(Integer(ExtendFlagTypeEnum.emTrackColor), RGB(255, 0, 0));	//Զʶı߿ɫ
		 InitCaptureParamW(Integer(ExtendFlagTypeEnum.emEditBorderColor), RGB(0, 174, 255));	//ֱ༭߿ɫ
		 InitCaptureParamW(Integer(ExtendFlagTypeEnum.emTransparent), 240); //ù͸
     InitCaptureParamW(Integer(ExtendFlagTypeEnum.emWindowAware), 1); //˺贰ڴǰãͬ´
     InitScreenCaptureW('niuniu');
     Niuniu_InitGdiPlus();
     Niuniu_InitRichEditWnd(self.Handle, redChatMessage.Handle);
     Niuniu_InitRichEditWnd(self.Handle, redSendMessage.Handle);
end;

procedure TfrmMain.AddMsgToRecord(lpText:Pchar);     //Ϣ¼
var
     strTitle:Pchar;
begin
     if length(lpText) = 0 then       //жϢǷΪ
     Exit;
     Niuniu_SetSel(redChatMessage.Handle, -1, -1);
     strTitle := Pchar('ţţ '+FormatDateTime('hh:mm:ss', Now())+#13#10);
     Niuniu_ReplaceSel(redChatMessage.Handle, strTitle, '΢ź', 12, clRed, True, False, False, False, 0);
     Niuniu_SetStartIndent(redChatMessage.Handle, 350);
     Niuniu_AppendMsg(redChatMessage.Handle, Pchar(lpText+#13#10));
     Niuniu_SetStartIndent(redChatMessage.Handle, 0);
     redChatMessage.Perform(WM_VSCROLL, SB_BOTTOM, 0);
end;

procedure TfrmMain.btnSendClick(Sender: TObject);      //Ϣ
var
     pcharContent:Pchar;
begin
     pcharContent:=Niuniu_GetRichTextContent(redSendMessage.Handle);
     AddMsgToRecord(pcharContent);
     redSendMessage.Clear;
     redSendMessage.SetFocus;
end;

procedure TfrmMain.OnEmotionSelected(var nID : Integer);
var strPath : string;
begin
    strPath:=ExtractFilePath(Paramstr(0))+'Emotion\' + format('%d',[nid]) + '.gif';
    Niuniu_InsertImage(redSendMessage.Handle, Pchar(strPath));
end;

procedure TfrmMain.OnRichEditRecordDblClk(Sender: TObject);
var
     pt: TPoint;
     picPath : string;
     exePath : string;
begin
     GetCursorPos(pt);
     pt := redChatMessage.ScreenToClient(pt);
     picPath := Niuniu_GetOleObjectPathFromPoint(redChatMessage.Handle, pt.X, pt.Y);
     exePath:=ExtractFilePath(Paramstr(0))+ 'imageviewer.exe';
     if length(trim(picPath))<>0 then
     ShellExecute(self.Handle, 'open', PWideChar(exePath), PWideChar(picPath), 0, SW_SHOWNORMAL);
end;

procedure TfrmMain.redSendMessageDblClick(Sender: TObject);
var
     pt: TPoint;
     picPath : string;
     exePath : string;
begin
     GetCursorPos(pt);
     pt := redSendMessage.ScreenToClient(pt);
     picPath := Niuniu_GetOleObjectPathFromPoint(redSendMessage.Handle, pt.X, pt.Y);
     exePath:=ExtractFilePath(Paramstr(0))+ 'imageviewer.exe';
     if length(trim(picPath))<>0 then
     ShellExecute(self.Handle, 'open', PWideChar(exePath), PWideChar(picPath), 0, SW_SHOWNORMAL);
end;

procedure TfrmMain.btnInsertImageClick(Sender: TObject);    //ͼƬ
begin
     dlgInsertImage.Filter:='PNG (*.png)|*.png|BMP (*.bmp)|*.bmp|JPG (*.jpg;*.jpeg)|*.jpg;*.jpeg|GIF (*.gif)|*.gif'; //ļ
     dlgInsertImage.Options:=dlgInsertImage.Options+[ofReadOnly]-[ofHideReadOnly];
     if dlgInsertImage.Execute() then
     Niuniu_InsertImage(redSendMessage.Handle, Pchar(dlgInsertImage.FileName));
end;

procedure TfrmMain.btnCaptureClick(Sender: TObject);   //ͼ
var
     strPath, strPath1:string;
     strDsteTime:string;
begin
     strPath:=ExtractFilePath(Paramstr(0))+'TestCapture\';
     if not DirectoryExists(strPath) then
     ForceDirectories(strPath);
     DateTimeToString(strDsteTime, 'yyyymmdd hhnnss', Now());
     strCapturePath := Format('%s%s.png', [strPath, strDsteTime]);
     //string strPath1 = ScreenCaptureWrapper.get_uft8(m_strDefaultPath);  //ӦòҪת
     StartScreenCaptureW(strCapturePath, nil, self.Handle, WM_MY_MSG_SCREENNOTICE, nil, 0, 0, 0, 0, 0); //ӦøݽͼֵжǷɹֵû˵
end;

procedure TfrmMain.btnFaceClick(Sender: TObject);   //ʾ
var
     pt:TPoint;
begin
     pt:=dlgFace.ClientToScreen(self.ClientOrigin);
     dlgFace.Hide;
     dlgFace.Show;
     dlgMainHwnd := self.Handle;
     dlgFace.Left:=self.ClientOrigin.X + btnFace.Left;
     dlgFace.Top:=self.ClientOrigin.Y + btnFace.Top - dlgFace.Height;
end;

procedure TfrmMain.WndProc(var Message: TMessage);
begin
     if Message.msg=WM_MY_MSG_SCREENNOTICE then
     begin
          Niuniu_InsertImage(redSendMessage.Handle, Pchar(strCapturePath));
          Exit;
     end;
     if Message.msg=WM_MY_MSG_EMOTION_SELECTED then
     begin
          OnEmotionSelected(Message.WParam);
          Exit;
     end;
     inherited WndProc(Message);
end;

procedure TfrmMain.WMNotify(var AMessage: TWMNotify);
type
     PENLink = ^TENLink;
     TTextRange = TTextRangeA;
var
     selText:PChar;
begin
     inherited;
     if AMessage.NMHdr^.code = EN_PASTE then     //ճ
          if AMessage.NMHdr^.hWndFrom = redSendMessage.Handle then
          Niuniu_PasteMsg(redSendMessage.Handle, LongInt(AMessage.NMHdr));

     if AMessage.NMHdr^.code = EN_LINK then   //
          with PENLink(AMessage.NMHdr)^ do
               if (msg = WM_LBUTTONDOWN) then
               begin
                    selText := Niuniu_GetSelText(AMessage.NMHdr^.hwndFrom, chrg.cpMin, chrg.cpMax);
                    ShellExecute(self.Handle, 'open', selText, 0, 0, SW_SHOWNORMAL);
               end;

end;
end.

